File: fetch.sh
   1 #!/bin/sh
   2 
   3 # The MIT License (MIT)
   4 #
   5 # Copyright (c) 2026 pacman64
   6 #
   7 # Permission is hereby granted, free of charge, to any person obtaining a copy
   8 # of this software and associated documentation files (the "Software"), to deal
   9 # in the Software without restriction, including without limitation the rights
  10 # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  11 # copies of the Software, and to permit persons to whom the Software is
  12 # furnished to do so, subject to the following conditions:
  13 #
  14 # The above copyright notice and this permission notice shall be included in
  15 # all copies or substantial portions of the Software.
  16 #
  17 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  18 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  19 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  20 # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  21 # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  22 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  23 # SOFTWARE.
  24 
  25 
  26 # fetch [options...] [URIs/data-URIs...]
  27 #
  28 # Fetch/web-request all URIs given, using protcol HTTPS when none is given.
  29 # Base64-encoded data-URI are also supported, being simply decoded into the
  30 # bytes they represent, no loading/fetching required.
  31 #
  32 # The only options show this help message, via any of `-h`, `--h`, `-help`,
  33 # or `--help`.
  34 
  35 
  36 # This version is compatible with busybox/alpine-linux.
  37 
  38 # fail quits the script right after showing the message given, using the
  39 # exit code given as its 2nd arg
  40 fail() {
  41     if [ "$2" = 23 ] || [ "$2" = 141 ]; then
  42         exit 0
  43     fi
  44     printf "%s\n" "$1" >&2
  45     exit "${2:-1}"
  46 }
  47 
  48 
  49 case "$1" in
  50     -h|--h|-help|--help)
  51         awk '/^# +fetch /, /^$/ { gsub(/^# ?/, ""); print }' "$0"
  52         exit 0
  53     ;;
  54 esac
  55 
  56 [ "$1" = '--' ] && shift
  57 
  58 if [ $# -eq 0 ]; then
  59     awk '/^# +fetch /, /^$/ { gsub(/^# ?/, ""); print }' "$0"
  60     exit 0
  61 fi
  62 
  63 dashes=0
  64 for uri in "$@"; do
  65     if [ "${uri}" = '-' ]; then
  66         dashes="$(("${dashes}" + 1))"
  67     fi
  68 done
  69 
  70 if [ "${dashes}" -gt 1 ]; then
  71     printf "can't use dash (standard input) more than once\n" >&2
  72     exit 1
  73 fi
  74 
  75 trap 'exit 0' PIPE
  76 
  77 for uri in "$@"; do
  78     case "${uri}" in
  79         -) cat;;
  80 
  81         file://*)
  82             cat "$(echo "${uri}" | sed 's-^file://--')" ||
  83                 fail "failed to fetch ${uri}" $?
  84         ;;
  85 
  86         https://*|http://*|ftp://*|ftps://*|sftp://*|dict://*)
  87             curl -s -L "${uri}" || fail "failed to fetch ${uri}" $?
  88         ;;
  89 
  90         data:,) continue;;
  91         data:*)
  92             {
  93                 echo "${uri}" | sed -E 's-^data:.{0,50};base64,--' | base64 -d
  94             } || fail "failed to decode base64 payload from data URI" $?
  95         ;;
  96 
  97         *)
  98             if [ -e "${uri}" ]; then
  99                 cat "${uri}" || fail "failed to fetch ${uri}" $?
 100                 continue
 101             fi
 102 
 103             uri="https://${uri}"
 104             curl -s -L "${uri}" || fail "failed to fetch ${uri}" $?
 105         ;;
 106     esac
 107 done